import File, { FileType } from "../../models/FileSchema";
import { NextFunction, Request, Response } from "express";

const uploadCardImage = () => async (
  req: Request,
  res: Response,
  next: NextFunction
) => {
  const uploadedFile = req.file;
  if (!uploadedFile) {
    return res.status(400).send("File wasn't provided!");
  }
  const file = new File();

  file.originalName = uploadedFile.originalname;
  file.mimetype = uploadedFile.mimetype;
  file.path = uploadedFile.path;
  file.type = FileType.CARD_IMAGE;

  await file.save((err) => {
    if (err) {
      return res.status(400);
    }
  });
  return res.status(201).send(true);
};

export default uploadCardImage;
