import File, { FileType } from "../../models/FileSchema";
import { NextFunction, Request, Response } from "express";

import Profile from "../../models/ProfileSchema";
import fs from "fs";

const uploadProfilePicture = () => async (
  req: Request,
  res: Response,
  next: NextFunction
) => {
  const uploadedFile = req.file;
  if (!uploadedFile) {
    return res.status(400).send("File wasn't provided!");
  }

  Profile.findOne(
    { external_id: req.session!.user!.id },
    async (error, profile) => {
      if (error) {
        console.warn(error);
        res.status(400);
      } else {
        if (profile!.pictureId) {
          const oldFile = await File.findById(profile!.pictureId).exec();

          fs.unlink(oldFile!.path, (err) => {
            if (err) {
              console.error(err);
            }
          });

          await File.deleteOne({ _id: profile!.pictureId }).exec();
        }

        const newFile = new File();

        newFile.originalName = uploadedFile.originalname;
        newFile.mimetype = uploadedFile.mimetype;
        newFile.path = uploadedFile.path;
        newFile.type = FileType.CARD_IMAGE;

        await newFile.save((err) => {
          if (err) {
            return res.status(400);
          }
        });

        await Profile.updateOne(
          { external_id: req.session!.user!.id },
          { pictureId: newFile.id }
        ).exec();

        return res.status(200).send(true);
      }
    }
  );
};

export default uploadProfilePicture;
